package org.jbpm.jobexecutor;

import java.util.List;

import org.jbpm.env.session.Job;
import org.jbpm.env.session.Timer;
import org.jbpm.pvm.Execution;

/**
 * @author Tom Baeyens, Pascal Verdage
 */
public interface JobSession {

	/** save a job */
	public void save(Job<?> job);

	/** delete a job */
	public void delete(Job<?> job);

	/** @return the first job to finish among eligible and non-locked jobs*/
	public Job<?> getFirstAcquirableJob();

	/** */
	public List<Job<?>> findExclusiveJobs(Execution processInstance);

	/** */
	public Job<?> getFirstDueJob();

	/** */
	public Job<?> get(long jobId);

	/** */
	public Timer findNextTimer();

	/** */
	public List<Timer> findAllTimers();
	
	/** */
	public List<Timer> findTimers(Execution execution);
}
